/*
 *	loque\ChangeView.java
 *
 *	ChangeView-Befehl
 *
 *  $Id: ChangeView.java,v 1.4 2002/07/07 14:31:03 richard Exp $
 *
 */
package loque;

//log4j Klassen importieren
import org.apache.log4j.Category;
import org.apache.log4j.Priority;
import org.apache.log4j.NDC;

/**
 * Datenstruktur fuer ChangeView-Befehl
 */
public class ChangeView{

  static Category cat = Category.getInstance( ChangeView.class.getName());

	final public static short Normal = 1;
	final public static short Wide   = 2;
	final public static short Narrow = 0;
	final public static short High   = 0;
	final public static short Low    = 1;

  /** ViewWidth */
  private short width;
	/** ViewQuality */
	private short quality;

  /**
  * Konstruktor
  */
  public ChangeView( short Width, short Quality ){
    width = Width; quality = Quality;
  }

  /**
   * Wandelt diese Objekt in ein rcsss-Kommando um. Damit sparen wir uns
   * eine rel. aufwndiges encoden.
   *
   * @return Robocup-Server-Kommando
   */
  public String toString(){
		String sWidth = width == Narrow ? "narrow" : ( width == Wide ? "wide" : "normal" );
		String sQuality = quality == Low ? "low" : "high";
		return "(change_view "+sWidth+" "+sQuality+" )";
  }
}


/*
 * Version History:
 *
 * $Log: ChangeView.java,v $
 * Revision 1.4  2002/07/07 14:31:03  richard
 * Diverses privatisiert
 *
 * Revision 1.3  2002/07/06 20:02:29  matthias
 * Noch mehr Kommentare
 *
 * Revision 1.2  2002/06/04 12:17:03  richard
 * Halbzeit und ViewMode bearbeitet
 *
 * Revision 1.1  2002/06/03 22:15:27  richard
 * KI erweitert und korrigiert, ChangeView erstellt und eingebaut,
 * laeuft jetzt
 *
 *
 */