/*
 *	loque\DataCore.java
 *
 *	haelt alle verfuegbaren Daten ueber Umwelt
 *
 *  $Id: DataCore.java,v 1.17 2002/07/14 12:02:31 richard Exp $
 *
 */
package loque;

import java.io.Serializable;

// log4j Klassen importieren
import org.apache.log4j.Category;
import org.apache.log4j.Priority;
import org.apache.log4j.NDC;

/**
 *	haelt alle verfuegbaren Daten ueber Umwelt
 */
public class DataCore implements java.io.Serializable {

	static Category cat = Category.getInstance( DataCore.class.getName());

	// Konstanten
	public static final short LeftSide = 1;
	public static final short RightSide = 2;
	// Attribute
	public int dashpower;
	public int turnangle;
	public int turn_neckangle;
	public int kickangle;
	public int kickpower;
	/** der Teamname */
	public String teamname;
	/** die x-Koordinate der Spierlerposition */
	public int x;
	/** die y_Koordinate der Spierlerposition */
	public int y;
	/** die Geschwindigkeit des Spielers in x-Richtung */
	public int vx;
	/** die Geschwindigkeit des Spielers in y-Richtung */
	public int vy;
	/** die Gesamtgeschwindigkeit des Spielers */
	public int va;
	/**der Winkel in dem der Spieler zur Mittellinie steht, von oben im Uhrzeigersinn positiv gerechnet, gegen den Uhrzeigersinn negativ */
	public int dir;
	/** der Winkel, um den der Spieler seinen Kopf gedreht hat, relativ zu Krper */
	public int headdir;
	/** Richtung der Bewegung */
	public int speedDir;
	/** das Stamina des Spielers */
	public int stamina;
	/** der Ball */
	public FieldObjekt ball;
	/** array der eigenen Mitspieler, die der Spieler sieht */
	public FieldObjekt[] friend;
	/** Nummer der gueltigen Friend-Objekte */
	public int numFriends;
	/** array der gegnerischen Spieler, die der Spieler sieht */
	public FieldObjekt[] enemy;
	/** Nummer der gueltigen Friend-Objekte */
	public int numEnemies;
	/** array der unbekannten Spieler, die der Spieler sieht */
	public FieldObjekt[] unknown;
	/** Nummer der gueltigen Friend-Objekte */
	public int numUnknowns;
	/** die Spielernummmer */
	public short num;
	/** gibt an, ob es sich bei dem Spieler um den Torwart handelt oder nicht */
	public boolean goalie;
	/** gibt die Spielfeldseite an(1 fr links, 2 fr rechts */
	public short side;
	/** gibt an, ob der Spieler teleportiert wurde */
	public boolean teleported;
	/** die Nummer des cycles */
	public int cycle;
	/** der Winkel um den der Kopf gedreht werden soll */
	public int turnNeckRequest;
	/** die Blickwinkelbreite */
	public short viewWidth;
	/** Goalie links hat den ball gefangen*/
	public boolean goalie_catch_ball_enemy = false;
	/** Goalie rechts hat den ball gefangen*/
	public boolean goalie_catch_ball_friend = false;
	/** Freisto links */
	public boolean free_kick_enemy = false;
	/** Freisto rechts */
	public boolean free_kick_friend = false;
  /** wird von Aktion.Validate benoetigt */
  public boolean seeCycle = true;

	/**
	 * Konstruktor
	 * Setzt alle Attribute auf ihre Anfangswerte
	 */
	public DataCore(){
		int a; x=0;y=0;vx=0;vy=0;va=0;dir=0;headdir=0;stamina=4000;
		teleported = true; goalie = false; side = 1;
		friend = new FieldObjekt[10]; numFriends = 0;
		enemy = new FieldObjekt[11]; numEnemies = 0;
		unknown = new FieldObjekt[21]; numUnknowns = 0;
		delete(); cycle = 0; turnNeckRequest = 0; viewWidth = ChangeView.Normal;
	}
	/** lscht alle Referenzen */
	public void delete(){
		int a; ball = null;
		for( a = 0; a < 10; a++ )friend[a]=null; numFriends = 0;
		for( a = 0; a < 11; a++ )enemy[a]=null; numEnemies = 0;
		for( a = 0; a < 21; a++ )unknown[a]=null; numUnknowns = 0;
	};

	/**
	 * Betrag eines Winkels
         *  @param angle der Winkel, dessen Betrag gewnscht wird
	 */
	public static int abs( int angle ){
		return angle < 0 ? -angle : angle;
	}

	/**
	 * normiert Winkel auf -180 bis 180
         *  @param a der zu normierende Winkel
	 */
	public static int normAngle( int a ){
		while( a < -18000 )a += 36000;
		while( a > 18000 )a -= 36000;
		return a;
	}

}

/*
 * Version History:
 *
 * $Log: DataCore.java,v $
 * Revision 1.17  2002/07/14 12:02:31  richard
 * Trainigslager Ver.3
 *
 * Revision 1.16  2002/07/13 20:09:31  richard
 * trainingslager ver1
 *
 * Revision 1.15  2002/07/02 12:03:28  richard
 * neuer Algorithmus fuer WorldModell
 *
 * Revision 1.14  2002/06/24 22:00:56  richard
 * KI bearbeitet, intercept auskommentiert, da noch nicht zufriedenstellend...
 *
 * Revision 1.13  2002/06/24 18:53:56  matthias
 * Goal, nochmaliger debug.
 * play_on eingefuegt
 *
 * Revision 1.12  2002/06/23 21:06:47  richard
 * History in WorldModell eingefuegt, IO_Translate korrigiert bezueglich goal,
 * KI-Daten an DataCore verbessert, ...
 *
 * Revision 1.11  2002/06/20 17:17:17  matthias
 * Freistoss und Goalie catch ball eingefuegt
 *
 * Revision 1.10  2002/06/20 13:47:49  richard
 * DataCore repariert
 *
 * Revision 1.9  2002/06/19 15:33:13  dhenning
 * Funktionen/Variablen fr History
 *
 * Revision 1.8  2002/06/18 15:16:39  richard
 * numFriends,... zu DataCore hinzugefuegt und in WorldModell eingebaut,
 * ListeningPort jetzt dynamisch ueber Commandozeile
 *
 * Revision 1.7  2002/06/18 09:18:03  dhenning
 * neue Variablen fr History
 *
 * Revision 1.5  2002/06/13 14:50:13  matthias
 * Teamnamen eingefgt
 *
 * Revision 1.4  2002/06/03 22:15:27  richard
 * KI erweitert und korrigiert, ChangeView erstellt und eingebaut,
 * laeuft jetzt
 *
 * Revision 1.3  2002/06/02 13:17:45  richard
 * Log4J aktiviert, Header korrigiert, Einheitenkommentare hinzugefuegt, Umrechnung der Einheiten hinzugefuegt, allgemeine Korrekturen
 *
 * Revision 1.2  2002/05/28 14:31:52  bbleiffus
 * log4j Grundstruktur auskommentiert eingefgt
 *
 * Revision 1.1  2002/05/28 12:33:06  richard
 * moving files
 *
 * Revision 1.5  2002/05/25 20:56:07  richard
 * Feel-Class hinzugefuegt and deren Auswertung
 *
 * Revision 1.4  2002/05/25 16:50:07  richard
 * rudimentaeres StartUp erstellt, Haupt-Playerschleife und Login hinzugefuegt
 *
 * Revision 1.3  2002/05/25 14:55:23  richard
 * added package-statements, worked on the WorldModell, added Line-Class
 *
 * Revision 1.2  2002/05/24 14:21:20  richard
 * habe Log korrigiert
 *
 *
 */