/*
 *	loque\Flag.java
 *
 *	See-Nachricht fuer Flags
 *
 *  $Id: Flag.java,v 1.7 2002/07/07 14:31:03 richard Exp $
 *
 */

package loque;


/**
 *	See-Nachricht fuer Flags
 */
public class Flag {


  /* Attributes */
  /** Richtung, in der Flag steht(in 1/100 Grad) */
  private int dir;
  /** Entfernung, in der Flag steht(in 1/100 Meter) */
  private int dist;
  /** absolute Koordinaten aus Liste */
  private int ax, ay;
  /**
   * Konstruktor
   */
  public Flag( int iDist, int iDir, int iAx, int iAy ){
	  dir = iDir; dist = iDist; ax = iAx; ay = iAy;
  }
	/*
	 * der folgende Teil wird fuer Berechnungen im WorldModell
	 * bentigt
	 */
	/** Spielerposition nach Flagge */
	public int px,py;
	/** Genauigkeit der Position */
	public int exact;
	/** Spielerposition berechnen unter Angabe der absoluten Blickrichtung */
	public int calcPosition( int playerDir ){
		double flagDir = (playerDir+dir+18000)*0.01*Math.PI/180.0;
		px = (int)(ax + dist*Math.sin(flagDir));
		py = (int)(ay - dist*Math.cos(flagDir));
		exact = 6000 / ( dist + 1000 );
		if( exact < 1 )exact = 1;
		if( exact > 5 )exact = 5;
		return exact;
	};

}

/*
 * Version History:
 *
 * $Log: Flag.java,v $
 * Revision 1.7  2002/07/07 14:31:03  richard
 * Diverses privatisiert
 *
 * Revision 1.6  2002/07/06 20:02:47  matthias
 * Noch mehr Kommentare
 *
 * Revision 1.5  2002/07/05 11:10:07  richard
 * interception verbessert und Positionsbestimmung berarbeitet
 *
 * Revision 1.4  2002/06/02 22:29:33  richard
 * habe diverse Korrekturen vorgenommen, KI geschrieben,
 * einige IO Bugs entfernt, usw.
 *
 * Revision 1.3  2002/06/02 13:17:45  richard
 * Log4J aktiviert, Header korrigiert, Einheitenkommentare hinzugefuegt, Umrechnung der Einheiten hinzugefuegt, allgemeine Korrekturen
 *
 * Revision 1.2  2002/05/28 14:31:52  bbleiffus
 * log4j Grundstruktur auskommentiert eingefgt
 *
 * Revision 1.1  2002/05/28 12:33:06  richard
 * moving files
 *
 * Revision 1.4  2002/05/27 20:13:55  matthias
 * IOTrans: Ball Erkennung hinzugefgt
 * See: Koordinaten korigiert 1/100
 *
 * Revision 1.3  2002/05/25 14:55:23  richard
 * added package-statements, worked on the WorldModell, added Line-Class
 *
 * Revision 1.2  2002/05/24 14:21:20  richard
 * habe Log korrigiert
 *
 *
 */
