/*
 *	loque\KI.java
 *
 *	enthaelt alle Teile der Entscheidungsfindung
 *
 *  $Id: KI.java,v 1.58 2002/07/14 14:36:04 richard Exp $
 *
 */

package loque;

// log4j Klassen importieren
import org.apache.log4j.Category;
import org.apache.log4j.Priority;
import org.apache.log4j.NDC;


/**
 *  enthaelt alle Teile der Entscheidungsfindung
 */
public class KI {
	static Category cat = Category.getInstance( KI.class.getName());
  /** Referenz auf Spieler*/
  private Player parent;
	/** zuletzt bearbeitete Aktion */
	private Aktion lastAktion = null;
	/** Feld-Abmessungen u. Kick-Off Position; left, top, right, bottom, x, y */
	private Field leftFields[]  =
	{  new Field( -5300, -2017, -4000,  2017, -4800,     0, -4800,     0 ),
		 new Field( -8000, -3500,  -500,  -700, -2250, -1500, -2500, -1500 ),
		 new Field( -8000, -1100,  -500,  1100, -2250,     0, -2500,     0 ),
		 new Field( -8000,   700,  -500,  4000, -2250,  1500, -2500,  1500 ),
		 new Field( -2000, -4000,  2000, -1200,   250, -2250,  -100, -2250 ),
		 new Field( -2000, -1800,  2000,   400,  -250,  -750,   -10,     0 ),
		 new Field( -2000,  -400,  2000,  1800,  -250,   750,  -500,     0 ),
		 new Field( -2000,  1200,  2000,  4000,   250,  2250,  -100,  2250 ),
		 new Field(   500, -4000,  8000,  -500,  1750, -1400,  -100, -1400 ),
		 new Field(   700, -1250,  8000,  1250,  2250,     0,  -600,  -500 ),
		 new Field(   500,   500,  8000,  4000,  1750,  1400,  -100,  1400 ) };

	/** gesamtes Spielfeld */
	private static final Field playground = new Field( -5250, -3400, 5250, 3400, 0, 0, 0, 0 );
  /** Definition des linken Tores */
  private static final FieldObjekt rightGoal = new FieldObjekt( 5250, 0, 0, 0, 0, 0, (short)0, 0, 0, (short)0 );
  /** Definition des rechten Tores */
  private static final FieldObjekt leftGoal = new FieldObjekt( -5250, 0, 0, 0, 0, 0, (short)0, 0, 0, (short)0 );
  /** Zuweisung der Tore */
	private FieldObjekt enemyGoal, myGoal;
  /** Felderstellung */
	private Field       fields[];
  /** Spielereigenes Feld */
	private Field				myField;
	/** Winkel in Vorwaertsrichtung */
	private int					forwardDir;
	/** Vorzeichen fuer X-Bewegung zum Gegnertor */
	private int					forwardSign;
	/** kleinste abseitssichere Position */
	private int					minSecureX;

	//============================================================================
  /**
   * Konstruktor
   */
  public KI( Player rParent ){
		parent=rParent;
		// Fields vervollstaendigen
		int dummy[][][] = {{{5,6,4,7,},{2,1,3},{}},
											 {{4,5,6,7},{2,3},{}},
											 {{5,6,4,7},{1,3},{}},
											 {{7,6,5,4},{2,1},{}},
											 {{8,9,10},{5,6,7},{1,2,3}},
											 {{9,8,10},{4,6,7},{2,1,3}},
											 {{9,10,8},{7,5,4},{2,3,1}},
											 {{10,9,8},{6,5,4},{3,2,1}},
											 {{},{9,10},{5,4,6,7}},
											 {{},{8,10},{5,6,4,7}},
											 {{},{9,8},{6,7,5,4}}};
		for( int a = 1; a < 11; a++ ){
			leftFields[a].forward = dummy[a][0];
			leftFields[a].sideward = dummy[a][1];
			leftFields[a].backward = dummy[a][2];
		}
  }

	//============================================================================
  /**
   *  Spieler KI
   *  ruft thinkGoalie auf fuer Torwart und arbeitet selbst fuer Feldspieler
   */
	public void think(){
    DataCore data = parent.datacore;
		if( data.ball != null )
			for( int z = 1; z < 11; z++ )fields[z].moveTo( data.ball.x );
		if( data.num == 1 ){
			thinkGoalie();
			return;
		}
		if( lastAktion != null && lastAktion.aktionID == Aktion.Validate &&
				lastAktion.complete )
			getMinSecureX();
		if( lastAktion != null && !lastAktion.complete ){
			if( lastAktion.aktionID == Aktion.Intercept && data.ball != null ){
				Aktion interception = intercept();
				if( myField.containsExtended( interception.tx, interception.ty ) &&
						( friendliesNear( data.ball.x, data.ball.y, 200 ) < 2 
							|| data.ball.dist < 200 ) && !data.goalie_catch_ball_friend ){ 
					execute( lastAktion ); return;
				}
			}
			else if( lastAktion.aktionID != Aktion.IdleToSoll && 
							 lastAktion.age < 20 ){
				execute( lastAktion ); return;
			}
		}
		// hier geht es los...
		// bin ich zustndig?
		if( !data.free_kick_enemy && !data.goalie_catch_ball_enemy && 
				!data.goalie_catch_ball_friend ){
			Aktion interception = intercept();
			if( data.ball != null && ( data.stamina > 1000 || data.ball.dist < 500 )
					&& ( myField.contains( interception.tx, interception.ty ) ||
					 ( data.ball.dist < 400 &&
						 myField.containsExtended( interception.tx, interception.ty ) ) )
				 ){
				// Ball abfangen?
				if( data.ball.dist > 150 ){
					if( friendliesNear( interception.tx, interception.ty, 400 ) < 2 &&
							friendliesTo( interception.tx, interception.ty ) < 2 ){
						execute( interception ); return;
					}
				}
				else{
					// Ball in Reichweite, AKTION !!!!
					// Torschuattacke?
					int dist = distTo( enemyGoal.x, enemyGoal.y );
					int absAngle = absAngleTo( enemyGoal.x, enemyGoal.y );
					if( dist < 5000 || ( data.free_kick_friend && 
															 data.ball.x*forwardSign > -1000 ) ){
						// kurz vorm Tor? -> Feuer frei !!!
						if( dist <= 3500 || ( data.free_kick_friend && 
															 data.ball.x*forwardSign > -1000 ) ){
							// schlechter Winkel->Rueckpass
							if( DataCore.abs( DataCore.normAngle( absAngleTo( enemyGoal.x,
									enemyGoal.y ) - forwardDir ) ) > 7000 ){
								rueckpass(); return;
							}
							execute( new Aktion( Aktion.Goalkick ) ); return;
						}// koennen wir abgeben?
						if( myField.forward != null ){
							for( int a = 0; a < myField.forward.length; a++ ){
								Aktion pass = passTo( myField.forward[a] );
								if( forwardSign*(pass.tx-data.x) < 700 )continue;
								if( unfriendliesTo( pass.tx, pass.ty, true ) == 0 &&
										unfriendliesNear( pass.tx, pass.ty, 500, true ) == 0 ){
									execute( pass ); return;
								}
							}
						}// Weg frei zum Tor? -> dribbeln
						if( unfriendliesTo( absAngle, 1200, true ) == 0 &&
								unfriendliesNear( data.x, data.y, 400, true ) == 0 ){
							execute( aktionInDir( Aktion.Tribbling, absAngle, 500 ) );
						}
						// sonst abziehen
						// schlechter Winkel->Rueckpass
						if( DataCore.abs( DataCore.normAngle( absAngleTo( enemyGoal.x,
								enemyGoal.y ) - forwardDir ) ) > 7000 ){
							rueckpass(); return;
						}
						execute( new Aktion( Aktion.Goalkick ) ); return;
					}
					// zu weit vom Tor entfernt...
					//Moeglichkeiten pruefen
					int bestNumber = 3, current;
					Aktion bestAktion = null;
					//abgeben?
					if( myField.forward != null ){
						for( int a = 0; a < myField.forward.length; a++ ){
							Aktion pass = passTo( myField.forward[a] );
							if( forwardSign*(pass.tx-data.x) < 700 )continue;
							current = unfriendliesTo( pass.tx, pass.ty, true );
							if( current < bestNumber ){
								bestNumber = current; bestAktion = pass;
							}
						}
					}// dribbeln?
					current = unfriendliesInDir( forwardDir, 800, true );
					if( current < bestNumber &&
							unfriendliesNear( data.x, data.y, 300, true ) == 0 ){
						bestNumber = current;
						bestAktion = aktionInDir( Aktion.Tribbling, forwardDir, 500 );
					}
					// Variante ok?
					if( bestNumber < 3 && ( bestAktion.aktionID != Aktion.Tribbling ||
																	bestNumber == 0 ) ){
						execute( bestAktion ); return;
					}// Richtung Tor vorlegen...
					execute( aktionInDir( Aktion.KickTo, forwardDir, 1000 ) ); return;
				}//END ELSE BAll in Reichweite
			}// END IF BALL in ExtendedField
		}
		// nix zu tun...
		if( ( !data.free_kick_enemy && !data.goalie_catch_ball_enemy ) ||
				( data.ball != null &&
					distBetween( data.ball.x, data.ball.y, offsideSecureX(),
											 myField.centerY ) > 900 ) ){
			if( distTo( offsideSecureX(), myField.centerY ) > 200 ){
				// zur Sollposition laufen
				if( myField.centerX*forwardSign < 0 ||
						( lastAktion != null &&	( lastAktion.aktionID == Aktion.Validate ||
																			( lastAktion.aktionID == Aktion.IdleToSoll
																				&& lastAktion.age < 15  ) ) ) ){
					execute( lastAktion != null &&
									 lastAktion.aktionID == Aktion.IdleToSoll ?
									 lastAktion :	new Aktion( Aktion.IdleToSoll ) ); return;
				}
				execute( new Aktion( Aktion.Validate ) ); return;
			}
			if( myField.oCx*forwardSign > 0 && lastAktion != null
					&& lastAktion.aktionID == Aktion.TurnToBall ){
				execute( new Aktion( Aktion.Validate ) ); return;
			}
		}
		execute( new Aktion( Aktion.TurnToBall ) ); return;
	}

	//============================================================================
  /**
   *  spielt zurueck (vorm Tor)
   */
	private void rueckpass(){
		Aktion aktion;
		int dir = absAngleTo( forwardSign*3500, 0 );
		// Weg frei? tribbeln!
		if( unfriendliesInDir( dir, 700, true ) == 0 ){
			execute( aktionInDir( Aktion.Tribbling, dir, 500 ) ); return;
		}
		// passen moeglich?
		for( int a = 0; a < myField.sideward.length; a++ ){
			aktion = passTo( myField.sideward[a] );
			if( unfriendliesTo( aktion.tx, aktion.ty, true ) == 0 ){
				execute( aktion ); return;
			}
		}
  	// hilft nix, zurueckhauen
		execute( new Aktion( Aktion.KickTo, forwardSign*3500, 0 ) );
		return;
	}
	
	//============================================================================
  /**
   *  Torwart KI
   */
  private void thinkGoalie(){
		DataCore data = parent.datacore;
		// alte Aktion fortfuehren!
		if( lastAktion != null && !lastAktion.complete ){
			if( lastAktion.aktionID == Aktion.Intercept ){
				Aktion dummy = intercept();
				if( myField.contains( dummy.tx, dummy.ty ) ){
					execute( lastAktion ); return;
				}
			}
			if(	lastAktion.aktionID == Aktion.TurnNLook ){
				execute( lastAktion ); return;
		  }
		}
		// Ball gefangen
		if( data.goalie_catch_ball_friend && 
				lastAktion.aktionID != Aktion.TurnNLook ){
			if( lastAktion.aktionID != Aktion.Nothing )
				execute( new Aktion( Aktion.Nothing ) ); 
			else if( lastAktion.age < 15 )execute( lastAktion );
			else execute( turnInDir( forwardDir ) ); 
			return;
		}
    Aktion interceptAktion = intercept();
		// wenn kein Ball oder Ball weit weg zur SollPosition
    if( data.ball == null
				|| ( distBetween( myField.centerX, myField.centerY,
												data.ball.x, data.ball.y ) > 2500
						&& !myField.contains( interceptAktion.tx, interceptAktion.ty ) ) ){
			if( distTo( myField.centerX, myField.centerY ) > 100 )
				execute( lastAktion != null && lastAktion.aktionID == Aktion.IdleToSoll
								 ? lastAktion : new Aktion( Aktion.IdleToSoll ) );
			else execute( new Aktion( Aktion.TurnToBall ) );
			return;
		}
		// wenn wir frei draufhalten koennen, tun wir es:
    if( ( data.ball.va < 25 || data.goalie_catch_ball_friend ||
					data.free_kick_friend )	&& myField.contains( data.ball ) ){
      if( data.ball.dist > 200 ){
        execute( intercept() ); return;
      }
			//Hier wird vor dem Abschlag nach gegnern gesucht. Scheint zu funktionieren
			int bestAngle = 0, lowest = 4, curr; 
      for( int relDir = 0; relDir <= 1250; relDir += 250 ){
				curr = unfriendliesInDir( forwardDir + relDir, 2000, false );
				if( curr < lowest ){ lowest = curr; bestAngle = relDir; };
				curr = unfriendliesInDir( forwardDir - relDir, 2000, false );
				if( curr < lowest ){ lowest = curr; bestAngle = -relDir; };
			}
			execute( aktionInDir( Aktion.KickTo, forwardDir+bestAngle, 10000 ) );
			return;
    }
		// koennen wir den Ball abfangen?
		if( myField.contains( interceptAktion.tx, interceptAktion.ty ) ){
			// sollten doch lieber das Tor schuetzen?
    if( data.ball.dist > 800 &&
					unfriendliesNear( data.ball.x, data.ball.y, 250, false ) > 0 ){
        execute( new Aktion( Aktion.ProtectGoal ) ); return;
      }
      execute( interceptAktion ); return;
		}
		// Ball in der Naehe -> schuetzen
    execute( new Aktion( Aktion.ProtectGoal ) ); return;
	}

	//============================================================================
  /**
   * fuehrt eine Aktion aus
   */
	private void execute( Aktion aktion ){
		int angle, dist; DataCore data = parent.datacore;
		aktion.age++;	lastAktion = aktion;
		switch( aktion.aktionID ){
		//--------------------------------------------------------------------------
		case Aktion.Validate:
			// Aktion komplett, wenn bereits ausgefhrt und See-Message eingegangen
			// ist
			if( aktion.age > 1 && data.seeCycle ){
				aktion.complete = true; sendTurnNeck( 0 ); return;
			}
			// zum Gegnertor drehen
			angle = angleTo( enemyGoal.x, enemyGoal.y );
			if( DataCore.abs( angle ) > 9000 ){
				int turnA;
				if( angle < 0 ){ turnA = angle + 9000; angle = -9000; }
				else{ turnA = angle - 9000; angle = 9000; }
				turn( turnA );
			}
			data.turn_neckangle += angle-data.headdir;
			parent.ioTrans.encode( new Turn_Neck( angle-data.headdir ) );
			// und auf Weitwinkel schalten
			parent.ioTrans.encode(
				new ChangeView( ChangeView.Wide, ChangeView.High ) );
			parent.datacore.viewWidth = ChangeView.Wide; data.seeCycle = false;
			return;
		//--------------------------------------------------------------------------
		case Aktion.Tribbling:
			angle = angleTo( aktion.tx, aktion.ty );
			dist = distTo( aktion.tx, aktion.ty );
			// haben wir ueberhaupt Ball?
			if( data.ball == null || data.ball.dist > 600 )
				{ aktion.complete = true; sendTurnNeck(0); return; }
			// angekommen?
			if( !aktion.vorgelegt && dist < 200 )
				aktion.complete = true;
			// zum Ball laufen?
			if( aktion.vorgelegt  ){
					turn( aktion.angle ); sendTurnNeck( -aktion.angle );
					aktion.vorgelegt = false; return;
			}
			if( data.ball.dist > 60 ){
				closeIntercept( aktion );
				return;
			}
			// Stueck vorlegen
			kickInDir( angle, 400 ); sendTurnNeck( 0 );
			if( DataCore.abs( angle ) > 1000 )
				{aktion.vorgelegt = true; aktion.angle = angle; }
			return;
		//--------------------------------------------------------------------------
		case Aktion.Pass:
			// Zielpunkt bestimmen
			if( aktion.tx == 0 && aktion.age == 1 ){
				Aktion dummy = passTo( aktion.targetField );
				aktion.tx = dummy.tx; aktion.ty = dummy.ty;
			}
		//--------------------------------------------------------------------------
		case Aktion.KickTo:
			// zu Koordinaten kicken
			angle = angleTo( aktion.tx, aktion.ty );
			dist = distTo( aktion.tx, aktion.ty );
			// kein Ball? -> fertig
			if( data.ball == null ){
				sendTurnNeck(0); aktion.complete = true; return;
			}
			// Ball zu weit weg?
			if( data.ball.dist > 500 )aktion.complete = true;
			// zum Ball laufen?
			if( data.ball.dist > 60 ){
				closeIntercept( aktion ); return;
			}
			// und treten
			kickInDir( angle, dist ); sendTurnNeck( 0 );
			aktion.complete = true;
			return;
		//--------------------------------------------------------------------------
		case Aktion.Intercept:
			{
				// wenn kein gueltiger Ball aufhoeren
				if( data.goalie_catch_ball_friend && data.goalie == true )
					aktion.complete = true;
				if( data.ball == null ){
					sendTurnNeck( 0 ); aktion.complete = true; return;
				}
				// fertig?
				if( aktion.age > 1 ){
					if( friendliesNear( data.ball.x, data.ball.y, data.ball.dist ) > 1 )
						aktion.complete = true;
					if( DataCore.abs( DataCore.normAngle(
							aktion.lastBallDir - data.ball.dir ) ) > 1500 &&
							data.ball.va > 70 )
						// Ball wurde gekickt!
						aktion.complete = true;
					// Daten updaten
					Aktion newOne = intercept();
					int diff = distBetween( aktion.tx, aktion.ty, newOne.tx, newOne.ty );
					if( 100*diff/data.ball.dist > 50 )
						aktion.complete = true;
					aktion.tx = newOne.tx; aktion.ty = newOne.ty;
					aktion.angle = newOne.angle;
				}
				if( data.ball.age >= 10 ){
					execute( new Aktion( Aktion.TurnToBall ) ); lastAktion = aktion;
					return;
				}
				dist = distTo( aktion.tx, aktion.ty );
				angle = absToRel( aktion.angle );
				// wird er uns erreichen im naechsten Cycle?
				if( distTo( data.ball.nextX, data.ball.nextY ) < 150 &&
						( !data.goalie || data.free_kick_friend ) )
					aktion.complete = true;
				// koennen wir ihn fangen?
				if( data.goalie && !data.free_kick_friend && data.ball.dist < 175 ){
					sendCatch( angleTo( data.ball ) ); aktion.complete = true;
					sendTurnNeck( 0 ); return;
				}
				// Zielpunkt zu weit?
				if( dist > 60 ){
					if( DataCore.abs(angle) > 1500 ) {
						turn( angle ); sendTurnNeck( -angle ); return;
					}
					sendTurnNeck( 0 );
					dash( dashPower( dist ) );
					return;
				}
				// zum Ball drehen!
				angle = angleTo( data.ball );
				if( DataCore.abs(angle) > 99 ) {
					turn( angle ); sendTurnNeck( -angle ); return; }
				sendTurnNeck( 0 ); return;
			}
		//--------------------------------------------------------------------------
		case Aktion.ProtectGoal:
			// Torwart zwischen Ball und Tor stellen
			if( data.ball == null || data.goalie_catch_ball_friend ||
					data.free_kick_friend ){
				aktion.complete = true; sendTurnNeck(0); return;
			}
			// fangen wenn moeglich
			if( data.ball.dist < 175 ){
				//krall ihn dir!!!
				sendCatch( angleTo( data.ball ) ); sendTurnNeck( 0 );
				aktion.complete = true; return;
			}
			aktion.tx = myField.centerX;
			aktion.ty = (int)((double)data.ball.y/
												(1.0+((double)data.ball.x-myField.centerX)/
														 ((double)myField.centerX-myGoal.x)));
		//--------------------------------------------------------------------------
		case Aktion.Goto:
			dist = distTo( aktion.tx, aktion.ty );
			angle = angleTo( aktion.tx, aktion.ty );
			if( DataCore.abs(angle) > 1500 ){	turn( angle ); sendTurnNeck( -angle ); }
			else{	sendTurnNeck( 0 ); dash( dashPower( dist ) );	}
			if( dist < 150 && aktion.aktionID == Aktion.Goto )aktion.complete = true;
			return;
		//--------------------------------------------------------------------------
		case Aktion.Goalkick:
			if( aktion.age == 1 ){
				// Aiming...
				aktion.tx = enemyGoal.x; aktion.ty = enemyGoal.y;
				angle = angleTo( aktion.tx, aktion.ty );
  			dist = distTo( aktion.tx, aktion.ty );
				if( dist < 2000 && data.numEnemies > 0 ){
					// torwart suchen
					FieldObjekt goalie = null;
					int betterY = 0, tempAngle;
					for( int a = 0; a < data.numEnemies; a++ ){
						tempAngle = angleTo( data.enemy[a] ) - angle;
						if( DataCore.abs( tempAngle ) < 500 ){
							goalie = data.enemy[a];
							betterY = (tempAngle < 0 ? -600 : 600)*forwardSign; break;
						}
					}
					if( goalie != null ){
						// wenn torwart im Weg, vorbeispielen
						aktion.ty = betterY*(2000-dist)/2000;
						angle = angleTo( aktion.tx, aktion.ty );
						dist = distTo( aktion.tx, aktion.ty );
					}
				}
			}
			else{
				angle = angleTo( aktion.tx, aktion.ty );
				dist = distTo( aktion.tx, aktion.ty );
			}
			// kein Ball?
			if( data.ball == null || data.ball.dist > 500 ){
				aktion.complete = true; sendTurnNeck( 0 );	return;
			}
			// zum Ball laufen?
			if( aktion.vorgelegt ){
				turn( aktion.angle ); sendTurnNeck( -aktion.angle );
				aktion.vorgelegt = false; return;
			}
			if( data.ball.dist > 60 ){
				closeIntercept( aktion ); return;
			}
			if( dist < 2000 || 
					( data.ball.dist < 50 && DataCore.abs(angleTo(data.ball)) < 3000 )
				 || unfriendliesNear( data.x, data.y, 250, true ) > 0 ){
				//und draufhalten!
				kickInDir( angle, 15000 ); sendTurnNeck( 0 ); aktion.complete = true;
				return;
			}
			if( data.ball.va > 50 ){ 
				kickInDir( angle, 100 ); sendTurnNeck(0); aktion.vorgelegt = true; 
				return;
			}
			angle = angleTo( data.ball.nextX, data.ball.nextY );
			if( DataCore.abs( angle ) > 1500 ){
				turn( angle ); sendTurnNeck( -angle ); return;
			}
			dash( dashPower( distTo( data.ball.nextX, data.ball.nextY ) ) );
			sendTurnNeck( 0 ); 
			return;
		//--------------------------------------------------------------------------
		case Aktion.IdleToSoll:	// zur Sollposition laufen
			{
				boolean critical = false;
				int x = myField.centerX;
				if( forwardSign*x > forwardSign*minSecureX )x = minSecureX;
				angle = angleTo( x, myField.centerY );
				dist = distTo( x, myField.centerY );
				if( dist > 1000 && data.ball != null && data.ball.dist < 2000 )
					critical = true;
        if( ( aktion.age % 2 == 0 || data.stamina < 1500 ) &&
						forwardSign*minSecureX > forwardSign*data.x && !critical ){
					sendTurnNeck( 0 ); return;
				}
				int power = data.stamina/50;
				// wenn im Abseits, dann rennen !!!
				if( forwardSign*minSecureX < forwardSign*data.x || critical )
					power = 100;
				if( data.ball != null &&
						DataCore.abs( angle - angleTo( data.ball ) ) > 9000 ){
					// rueckwaerts laufen, wenn dadurch Ball besser im Blick
					power = -power; angle = DataCore.normAngle( angle + 18000 );
				}
				if( DataCore.abs(angle) > 1500 ){
					turn( angle ); sendTurnNeck( -angle ); return;
				}
				sendTurnNeck( 0 ); dash( power );
				if( dist < 200 )
					aktion.complete = true;
			}
			return;
		//--------------------------------------------------------------------------
		case Aktion.TurnToBall: // zum Ball drehen
			angle = DataCore.normAngle( forwardDir - data.dir );
			if( data.ball != null )angle = angleTo( data.ball );
			if( DataCore.abs( angle ) > 99 ){ turn( angle ); sendTurnNeck( -angle ); }
			else sendTurnNeck(0);
			aktion.complete = true;	return;
		//--------------------------------------------------------------------------
		case Aktion.TurnNLook:
			if( aktion.age > 1 && data.seeCycle )aktion.complete = true;
			angle = absToRel( aktion.angle );
			data.turnNeckRequest = 0;
			if( DataCore.abs( angle ) > 99 )turn( angle );
			sendTurnNeck( -data.headdir );			
			parent.ioTrans.encode( 
				new ChangeView( ChangeView.Wide, ChangeView.High ) );
			parent.datacore.viewWidth = ChangeView.Wide;
			if( aktion.age == 1 )data.seeCycle = false; 
			return;
		//--------------------------------------------------------------------------
		case Aktion.Nothing:
			sendTurnNeck(0); return;
		}
	}
	//============================================================================
	/**
	 * tut was es sagt
	 */
	private Aktion turnInDir( int Dir ){
		Aktion ret = new Aktion( Aktion.TurnNLook );
		ret.angle = Dir; return ret;
	}
	//============================================================================
  /**
   * liefert Pass-Objekt
   * @param TargetField das Ziel fr den Pass
   */
	private Aktion passTo( int TargetField ){
		Aktion aktion = new Aktion( Aktion.Pass, TargetField );
		int oldX = fields[aktion.targetField].centerX;
		int halfway = (parent.datacore.x+fields[aktion.targetField].centerX)/2;
		fields[aktion.targetField].moveTo( halfway );
		aktion.tx = fields[aktion.targetField].centerX;
		fields[aktion.targetField].centerX = oldX;
		if( aktion.tx*forwardSign > 3700 )aktion.tx = 3700*forwardSign;
		aktion.ty = fields[aktion.targetField].centerY;
		return aktion;
	}
	//============================================================================
  /**
   * abseitssicheres X fuer die Sollposition
   */
	private int offsideSecureX(){
		if( forwardSign*myField.centerX > forwardSign*minSecureX )return minSecureX;
		return myField.centerX;
	}
	//============================================================================
  /**
   * nicht eigene Spieler im Weg
   */
	private int unfriendliesTo( int x, int y, boolean UnknownsToo ){
		return unfriendliesInDir( absAngleTo( x, y ), distTo( x, y ), UnknownsToo );
	}
	//============================================================================
  /**
   * nicht eigene Spieler im Weg
   * Direction als absolute Angabe!!!
   */
	private int unfriendliesInDir( int Direction, int Distance,
																 boolean UnknownsToo ){
		DataCore data = parent.datacore; Distance+=250;
		int a, number = 0;
		for( a = 0; a < data.numEnemies; a++ ){
			if( DataCore.abs( DataCore.normAngle(
					Direction-data.enemy[a].angle ) ) < 700 &&
					data.enemy[a].dist < Distance )number++;
		}
		if( UnknownsToo ){
			for( a = 0; a < data.numUnknowns; a++ ){
				if( DataCore.abs( DataCore.normAngle(
						Direction-data.unknown[a].angle ) ) < 700 &&
						data.unknown[a].dist < Distance )number++;
			}
		}
		return number;
	}
	//============================================================================
  /**
   * eigene Spieler im Weg
   */
	private int friendliesTo( int x, int y ){
		return friendliesInDir( absAngleTo( x, y ), distTo( x, y ) );
	}
		//============================================================================
  /**
   * eigene Spieler im Weg
   * Direction als absolute Angabe!!!
   */
	private int friendliesInDir( int Direction, int Distance ){
		DataCore data = parent.datacore;
		int a, number = 0;
		for( a = 0; a < data.numFriends; a++ ){
			if( DataCore.abs( DataCore.normAngle(
					Direction-data.friend[a].angle ) ) < 700 &&
					data.friend[a].dist < Distance )number++;
		}
		return number;
	}
	//============================================================================
  /**
   * liefert Zahl der Mitspieler im Abstand von Radius
   */
	private int friendliesNear( int x, int y, int Radius ){
		DataCore data = parent.datacore;
		int a, dx, dy, number = 0; Radius *= Radius;
		for( a = 0; a < data.numFriends; a++ ){
			dx = data.friend[a].x-x; dy = data.friend[a].y-y;
			if( dx*dx+dy*dy < Radius )number++;
		}
		return number;
	}
	//============================================================================
  /**
   * liefert Zahl der Gegner im Abstand von Radius
   * um (x,y), Unknowns mitgezaehlt, falls UnknownsToo == true
   */
	private int unfriendliesNear( int x, int y, int Radius, boolean UnknownsToo ){
		DataCore data = parent.datacore;
		int a, dx, dy, number = 0; Radius *= Radius;
		for( a = 0; a < data.numEnemies; a++ ){
			dx = data.enemy[a].x-x; dy = data.enemy[a].y-y;
			if( dx*dx+dy*dy < Radius )number++;
		}
		if( UnknownsToo ){
			for( a = 0; a < data.numUnknowns; a++ ){
				dx = data.unknown[a].x-x; dy = data.unknown[a].y-y;
				if( dx*dx+dy*dy < Radius )number++;
			}
		}
		return number;
	}
	//============================================================================
  /**
   * liefert abseitssichere Position
   */
	private void getMinSecureX(){
		DataCore data = parent.datacore;
		boolean goalie = false;
		int High=0, sHigh=0,x=0;
		for( int a = 0; a < data.numEnemies; a++ ){
			x = data.enemy[a].x*forwardSign;
			if( x > High ){ sHigh = High; High = x; }
			else if( x > sHigh ){ sHigh = x; }
		}
		minSecureX = ( ( data.ball != null && data.ball.x*forwardSign > sHigh ) ?
								 data.ball.x : sHigh*forwardSign ) -150*forwardSign;
	}
	//============================================================================
  /**
   * Erstellung der Felder fr Spiel von rechts nach links
   */
	private Field[] createRightFields(){
    // Zuweisung der Spielpositionen von rechts nach links
		Field right[] = new Field[11], left;
    // Zuweisung der Felder fr Spiel von rechts nach links fr alle 11 Spieler
		for( int a = 0; a < 11; a++ ){
			left = leftFields[a];
			right[a] = new Field( -left.right, left.top, -left.left, left.bottom,
														-left.centerX, left.centerY,
														left.kickoffX, -left.kickoffY );
			right[a].forward = left.forward; right[a].sideward = left.sideward;
			right[a].backward = left.backward;
		}
		return right;
	}

	//============================================================================
	/**
	 * Verwaltung vor Spielbegin, Seitenwahl, Startaufstellung
	 */
	public void preStart(){
    /** Abfrage der Spielhlfte und davon abhngige Feldeinteilung */
		if( parent.datacore.side == DataCore.LeftSide ){
			fields = leftFields; myGoal = leftGoal; enemyGoal = rightGoal;
			forwardDir = 9000; forwardSign = 1; minSecureX = 5300;
		}else{
			fields = createRightFields(); myGoal = rightGoal; enemyGoal = leftGoal;
			forwardDir = -9000; forwardSign = -1; minSecureX = -5300;
		}
    /** Zuweisung der Felder an die Spieler nach Rckennummer */
		myField = fields[parent.datacore.num-1];
    /** Bewegung zur Kickoff-Position durch move-Befehl */
		move( myField.kickoffX, myField.kickoffY );
    /** Umstellung der Sichtweise auf Standard */
		parent.ioTrans.encode( new ChangeView( ChangeView.Normal,
																					 ChangeView.High ) );
		parent.datacore.dir = 9000;
	}

	//============================================================================
  /**
   * Kickoff-Position einnehmen bei Halbzeit und Sichtweise zu Standard ndern
   */
  public void halfTime(){
		move( myField.kickoffX, myField.kickoffY );
		parent.ioTrans.encode( new ChangeView( ChangeView.Normal,
																					 ChangeView.High ) );
		parent.datacore.dir = 9000;
  }

	//============================================================================
  /**
   * Kickoff-Positon einnehmen und Sichtweise auf Standard umstellen
   */
  public void goal(){
		move( myField.kickoffX, myField.kickoffY );
		parent.ioTrans.encode( new ChangeView( ChangeView.Normal,
																					 ChangeView.High ) );
  }

	//============================================================================
	/**
	 * Distanz von S zu T
	 */
  private int distBetween( int Sx, int Sy, int Tx, int Ty ){
		Sx -= Tx; Sy -= Ty; return (int)Math.sqrt( Sx*Sx+Sy*Sy );
	}
	//============================================================================
	/**
	 * Distanz zu Position
	 * @param x x-Wert des Vergleichspunkts
	 * @param y y-Wert des Vergleichspunkts
   * @return distBetween die Distanz zum Vergleichspunkt
	 */
  private int distTo( int x, int y ){
		return distBetween( parent.datacore.x, parent.datacore.y, x, y );
	}
	//============================================================================
	/**
	 * dashPower um Distanz zurueckzulegen
	 */
	private int dashPower( int Distance ){
		Distance -= 20;
		int power = (100*(Distance-parent.datacore.va))/60;
		if( power > 100 )power = 100;
		if( power < -100 )power = -100;
		return power;
	}
	//============================================================================
	/**
	 * absoluter Winkel zu relativem Winkel
	 */
	private int absToRel( int angle ){
		return DataCore.normAngle( angle - parent.datacore.dir );
	}
	//============================================================================
	/**
	 * absoluter Winkel zu Position
	 */
	private int absAngleTo( int x, int y ){
		return DataCore.normAngle(((int)((18000.0/Math.PI)*
								 Math.atan2( (double)(x - parent.datacore.x),
														 (double)(parent.datacore.y - y) ))));
	}
	//============================================================================
	/**
	 * relativer Winkel zu Objekt (keine fixe Positionen)
	 */
	private int angleTo( FieldObjekt objekt ){
  	return DataCore.normAngle(objekt.angle-parent.datacore.dir);
  }

	//============================================================================
	/**
	 *  relativer Winkel zu Position (fixe Positionen)
	 */
	private int angleTo( int x, int y ){
		return DataCore.normAngle(((int)((18000.0/Math.PI)*
								 Math.atan2( (double)(x - parent.datacore.x),
														 (double)(parent.datacore.y - y) )))
								 -parent.datacore.dir);
  }

	//============================================================================
	/**
   * Berechnen eines Abfangpunkt fuer Ball
   *  @return intercept-Aktion
   */
	// max Distanz die der Ball erreicht bei einem decay von 0.94 ist nach
	// der geometrischen Reihe: v/(1-0.94) = 16.66*v
	// hier: 12*v
  private Aktion intercept(){
		DataCore data = parent.datacore;
		Aktion temp = null;
		// kein Ball -> stehenbleiben
		if( data.ball == null ){
			temp = new Aktion( Aktion.Intercept, data.x, data.y );
			temp.complete = true; return temp;
		}
		if( data.free_kick_friend ){
			return new Aktion( Aktion.Intercept, data.ball.x, data.ball.y, 
												 data.ball.angle, data.ball.dir );
		}
		// Ball sehr nah oder sehr langsam -> direkt laufen
		if( data.ball.va < 25 ){
			return new Aktion( Aktion.Intercept, data.ball.nextX, data.ball.nextY,
												 absAngleTo( data.ball.nextX, data.ball.nextY ),
												 data.ball.dir );
		}
		// Einheitsvektor parallel target.dir:
		double va = (double)data.ball.va*0.01;
		double tx = 0.01*(double)(data.ball.vx)/va,
					 ty = 0.01*(double)(data.ball.vy)/va;
		double dx = 0.01*(double)(data.ball.x-data.x), 
					 dy = 0.01*(double)(data.ball.y-data.y);
		// othogonaler Einheitsvektor zu data.ball.dir:
		double ex = -ty, ey = tx;
		// Distanz zum Treffpunkt/ Balldistanz zum Treffpunkt:
		double d = (tx*dy-ty*dx)/(tx*ey-ty*ex), 
					 db = tx == 0.0 ? (d*ey-dy)/ty : (d*ex-dx)/tx;
		if( d < 0.0 ){ 
			d = -d; ex = -ex; ey = -ey; 
		}
		if( data.ball.dist < 500 ){
			//ohne turn?
			double bvx = 0.01*data.ball.vx, bvy = 0.01*data.ball.vy;
			double vx = 0.8*Math.sin( data.dir*Math.PI/18000.0 ),
						 vy = -0.8*Math.cos( data.dir*Math.PI/18000.0 );
			double nenner = bvx*vy-bvy*vx;
			if( nenner != 0.0 ){
				double t = (dy*vx-dx*vy)/nenner;
				double inTime = vy != 0.0 ? (dy+t*bvy)/vy : (dx+t*bvx)/vx;
				if( t > 0 && t < 7 && t > inTime && inTime > 0.0 ){
					temp = new Aktion( Aktion.Intercept, 
														 data.ball.x+(int)(t*data.ball.vx),
														 data.ball.y+(int)(t*data.ball.vy) );
				}
			}
			if( temp == null ){
				//mit turn
				int x = data.ball.x, y = data.ball.y;
				for( int a = 0; a < 7; a++ ){
					x+=data.ball.vx; y+=data.ball.vy;
					if( distTo( x, y ) < 80*a+50 ){
						temp = new Aktion( Aktion.Intercept, x, y );
						break;
					}
				}
			}
		}
		if( temp != null ){}
		// wenn der Ball uns trifft oder von uns weglaeuft:
		else if( d < (data.ball.dist < 500 ? 0.5 : 1.0 ) ){
			// wenn der Ball uns trifft
			if( db > 0.0 && db < 10.0*va )
				temp = new Aktion( Aktion.Intercept, data.x, data.y );
		}
		// wenn erreichbar, orthogonaler Winkel + Strecke
		else if( 1.6*d > (db+d/2)/va && db+d > 0 )
			temp = new Aktion( Aktion.Intercept, 
												 data.x+(int)(100.0*d*ex) + (int)(100.0*d*tx),
												 data.y+(int)(100.0*d*ey) + (int)(100.0*d*ty) );
		// kuerzer? -> o + 1/2
		else if( 1.414213562*d > db/va && db+d/2 > 0 )
			temp = new Aktion( Aktion.Intercept, 
												 data.x+(int)(100.0*d*ex) + (int)(50.0*d*tx),
												 data.y+(int)(100.0*d*ey) + (int)(50.0*d*ty) );
		// ultra lahm
		else if( 2*d < (db-d)/va && db > 10.0*va && db-d < 10.0*va )
			temp = new Aktion( Aktion.Intercept, 
												 data.x+(int)(100.0*d*ex) - (int)(100.0*d*tx),
												 data.y+(int)(100.0*d*ey) - (int)(100.0*d*ty) );
		// wenn data.ball zu uns kommt
		else if( db <= 10.0*va && db > 0 )
			temp = new Aktion( Aktion.Intercept, data.x+(int)(100.0*d*ex),
												 data.y+(int)(100.0*d*ey) );
		// zum Endpunkt der Ballbewegung laufen
		if( temp == null )
			temp = new Aktion( Aktion.Intercept, data.ball.x+10*data.ball.vx,
												 data.ball.y+10*data.ball.vy );
		// als Torwart nicht zu dicht ans Tor laufen!
		if( data.goalie && forwardSign*temp.tx < myField.centerX*forwardSign
			  && data.ball != null &&
				forwardSign*data.ball.x > forwardSign*myField.centerX ){
			// Korrektur fuer Torwart
			if( data.ball.vx == 0 )temp.tx = myField.centerX;
			else{
				temp.ty += data.ball.vy*(myField.centerX-temp.tx)/data.ball.vx;
				temp.tx = myField.centerX;
			}
		}
		// immer im Spielfeld bleiben
		if( !playground.contains( temp.tx, temp.ty ) ){
			if( temp.tx < playground.left ){
				if( data.ball.vx == 0 )temp.tx = playground.left;
				else{
					temp.ty += data.ball.vy*(playground.left-temp.tx)/data.ball.vx;
					temp.tx = playground.left;
				}
			}
			if( temp.ty < playground.top ){
				if( data.ball.vy == 0 )temp.ty = playground.top;
				else{
					temp.tx += data.ball.vx*(playground.top-temp.ty)/data.ball.vy;
					temp.ty = playground.top;
				}
			}
			if( temp.tx > playground.right ){
				if( data.ball.vx == 0 )temp.tx = playground.right;
				else{
				temp.ty += data.ball.vy*(playground.right-temp.tx)/data.ball.vx;
				temp.tx = playground.right;
				}
			}
			if( temp.ty > playground.bottom ){
				if( data.ball.vy == 0 )temp.ty = playground.bottom;
				else{
					temp.tx += data.ball.vx*(playground.bottom-temp.ty)/data.ball.vy;
					temp.ty = playground.top;
				}
			}
		}
		temp.lastBallDir = data.ball.dir;
		temp.angle = absAngleTo( temp.tx, temp.ty );
		return temp;
	}
	//============================================================================
  /**
	 * bewegt sich zum Ball
	 */
	private void closeIntercept( Aktion aktion ){
		DataCore data = parent.datacore;
		// kein Ball -> stehenbleiben
		if( data.ball == null ){
			aktion.complete = true; sendTurnNeck(0); return;
		}
		if( data.ball.dist > 500 )aktion.complete = true;
		int targetX=0, targetY=0; boolean ok = false;
		double dx = 0.01*(double)(data.ball.x-data.x), 
			dy = 0.01*(double)(data.ball.y-data.y);
		double bvx = 0.01*data.ball.vx, bvy = 0.01*data.ball.vy;
		double vx = 0.8*Math.sin( data.dir*Math.PI/18000.0 ),
			vy = -0.8*Math.cos( data.dir*Math.PI/18000.0 );
		double nenner = bvx*vy-bvy*vx;
		if( data.free_kick_friend ){
			targetX = data.ball.x; targetY = data.ball.y; ok = true;
		}
		else if( data.ball.va < 25 ){
			targetX = data.ball.nextX; targetY = data.ball.nextY; ok = true;
		}
		else if( nenner != 0.0 ){
			double t = (dy*vx-dx*vy)/nenner;
			double inTime = vy != 0.0 ? (dy+t*bvy)/vy : (dx+t*bvx)/vx;
			if( t > 0 && t < 7 && t > inTime && inTime > 0.0 ){
				targetX = data.ball.x+(int)(t*data.ball.vx);
				targetY = data.ball.y+(int)(t*data.ball.vy); ok = true;
			}
		}
		if( !ok ){
			//mit turn
			int x = data.ball.x, y = data.ball.y;
			for( int a = 0; a < 7; a++ ){
				x+=data.ball.vx; y+=data.ball.vy;
				if( distTo( x, y ) < 80*a+(data.goalie?170:50) ){
					targetX = x; targetY = y; ok = true;
					break;
				}
			}
		}
		if( !ok ){
			targetX = data.ball.nextX; targetY = data.ball.nextY; ok = true;
		}
		int angle = angleTo( targetX, targetY );
		if( DataCore.abs( angle ) > 1500 ){
				turn( angle ); sendTurnNeck( -angle ); return;
		}
		dash( dashPower( distTo( targetX, targetY ) ) );
		sendTurnNeck( 0 );
	}
		
	//============================================================================
  /**
	 * Distanz die Ball in t-Cyclen zuruecklegt
	 */
	private int ballDistIn( int cycles ){
		if( parent.datacore.ball == null )return 0;
		double faktor = 1.0;
		for( int a = 0; a < cycles; a++ )faktor *= 0.94;
		return (int)((1.0-faktor)*16.6666*parent.datacore.ball.va);
	}
	//============================================================================
  /**
	 * erstellt ein Aktion-Objekt fuer Richtung und Distanz
	 */
	private Aktion aktionInDir( short AktionID, int Direction, int Distance ){
		return new Aktion( AktionID,
											 parent.datacore.x+
											 (int)(Math.sin( Math.PI/18000.0*Direction )*Distance),
											 parent.datacore.y+
											 (int)(-Math.cos( Math.PI/18000.0*Direction )*Distance) );
	}
	//============================================================================
  /**
   * schiesst
   */
  private void kickInDir( int angle, int dist ){
		// absolute Zielrichtung in RAD
		double tdir = DataCore.normAngle( angle+parent.datacore.dir )*Math.PI/18000.0;
		double vx = 0, vy = 0; dist += 300;
		double malus = 0.0;
		if( parent.datacore.ball != null ){
			malus = (double)parent.datacore.ball.dist/70.0+
							(double)DataCore.abs(angleTo(parent.datacore.ball))/18000.0;
			malus = 1-0.25*malus; vx = parent.datacore.ball.vx*0.007;
			vy = parent.datacore.ball.vy*0.007;
		}
		// Zielgeschwindigkeiten
		double tva = dist/1666.6, tvx = tva*Math.sin( tdir ), 
					 tvy = -tva*Math.cos( tdir );
		// relative Geschwindigkeitsaenderung
		double rvx = tvx-vx, rvy = tvy-vy, rva = Math.sqrt( rvx*rvx+rvy*rvy );
		if( rva/(2.7*malus) > 1.0 ){
			// gewuenschte Entfernung ist nicht drin->Adaption
			double tx = tvx/tva, ty = tvy/tva;
			double ex = -ty, ey = tx;
			double d = (-tx*vy+ty*vx)/(tx*ey-ty*ex), 
				db = tx == 0.0 ? (d*ey+vy)/ty : (d*ex+vx)/tx;
			if( Math.abs(d) > 2.7*malus ){
				// unmglich!
				kick( 100, DataCore.normAngle( parent.datacore.ball.dir+18000 ) );
				return;
			}
			tdir += Math.sin( d/(2.7*malus) );
			angle = DataCore.normAngle( (int)(tdir*18000.0/Math.PI)-parent.datacore.dir );
			kick( 100, angle );
			return;
		}
		int o = DataCore.normAngle(angle+parent.datacore.dir);
		angle = (int)(18000.0/Math.PI*Math.atan2( rvx, -rvy ) );
		kick( (int)(100.0*rva/(2.7*malus)), 
					DataCore.normAngle( angle-parent.datacore.dir ) );
  }

	
	
	//============================================================================
	/**
    *  dreht Hals unter Beruecksichtigung von DataCore.turnNeckRequest
    *  @param angle Winkel entgegengesetzt zu TurnAngle
    */
	private void sendTurnNeck( int angle ){
		angle = DataCore.normAngle( angle + parent.datacore.turnNeckRequest );
		angle = DataCore.normAngle( parent.datacore.headdir+angle );
		if( angle > 9000 )angle = 9000; if( angle < -9000 )angle = -9000;
		angle = DataCore.normAngle( angle - parent.datacore.headdir );
		if( DataCore.abs( angle ) > 99 ){
			parent.ioTrans.encode( new Turn_Neck( angle ) );
			parent.datacore.turn_neckangle += angle;
		}
	}
	//============================================================================
  /**
   * erstellt einen kick-Befehl
   * @param angle relative Schussrichtung zur absoluten Ausrichtung des Spielers
   */
	private void kick( int power, int angle ){
		if( power > 100 )power = 100;
		parent.ioTrans.encode( new Kick( power , angle ) );
		parent.datacore.kickangle = angle;
		parent.datacore.kickpower = power;
	}
	//============================================================================
  /**
   * erstellt einen dash-Befehl
   * @param power gibt die Strke an mit der der Spieler "dashen" soll
   */
	private void dash( int power ){
		if( power > 100 )power = 100;
		if( power > parent.datacore.stamina )power = parent.datacore.stamina;
		if( power < 0 && -power < 2*parent.datacore.stamina )
			power = -parent.datacore.stamina/2;
		parent.ioTrans.encode( new Dash( power ) );
		parent.datacore.dashpower += power;
	}
	//============================================================================
  /**
   * erstellt einen turn-Befehl
   * @param angle Winkel um den sich der Spieler drehen soll
   */
	private void turn( int angle ){
		// ausgleichsrechnung:
		double penalty = 1.0+(double)parent.datacore.va*0.05;
		int amount = (int)(angle*penalty);
		if( amount > 18000 || amount < -18000 ){
			amount = amount > 18000 ? 18000 : -18000;
			angle = (int)(amount/penalty);
		}
		parent.datacore.turnangle += angle;
		parent.ioTrans.encode( new Turn( amount ) );
	}
	//============================================================================
  /**
   * erstellt einen move-Befehl
   */
	private void move( int x, int y ){
		parent.ioTrans.encode( new Move( x, y ) );
		parent.datacore.x = parent.datacore.side == DataCore.LeftSide ? x : -x;
		parent.datacore.y = parent.datacore.side == DataCore.LeftSide ? y : -y;
		parent.datacore.teleported = true;
		parent.world.resetSee( -1 );
	}
	//============================================================================
  /**
   * erstellt einen catch-Befehl
   */
	private void sendCatch( int angle ){
		parent.ioTrans.encode( new Catch( angle ) );
	}
}
//******************************************************************************
/**
 * eine Aktion
 */
class Aktion{
	public static final short Goalkick = 1, Pass = 2, Tribbling = 3,
					IdleToSoll = 4,	Goto = 5, Intercept = 6, KickTo = 7, Validate = 8,
					TurnToBall = 9,	ProtectGoal = 10, Nothing = 0, TurnNLook = 11;
	/** Aktionsart */
	public short aktionID;
	/** Zielkoordinaten */
	public int tx, ty;
	/** fertig? */
	public boolean complete;
	/** Alter der Aktion */
	public int age;
	/** Zielfeld (bei Pass) */
	public int targetField;
	/** hab ich einen Laufwinkel? */
	public int angle;
	/** letzte Ballrichtung fuer intercept */
	public int lastBallDir = 0;
	public boolean vorgelegt;
	/**
	 * Konstruktor fuer IdleToSoll, TurnToBall, ProtectGoal, GoalKick, Validate
	 */
	public Aktion( short ID ){
		aktionID = ID; tx = 0; ty = 0; targetField = 0; age = 0;
		complete = false; vorgelegt = false; angle = 0;
	}
	/**
	 * Konstruktor fuer Pass
	 */
	public Aktion( short ID, int TargetField ){
		aktionID = ID; tx = 0; ty = 0; targetField = TargetField; age = 0;
		complete = false; vorgelegt = false; angle = 0;
	}
	/**
	 * Konstruktor fuer Goto, KickTo, Tribbling
	 */
	public Aktion( short ID, int Tx, int Ty ){
		aktionID = ID; tx = Tx; ty = Ty; targetField = 0; age = 0;
		complete = false; vorgelegt = false; angle = 0;
	}
	/**
	 * Konstruktor fuer Intercept
	 */
	public Aktion( short ID, int Tx, int Ty, int Angle, int LastBallDir ){
		aktionID = ID; tx = Tx; ty = Ty; targetField = 0; age = 0;
		complete = false; vorgelegt = false; angle = Angle;
		lastBallDir = LastBallDir;
	}
}

//******************************************************************************
/**
 * ein Zustaendigkeitsbereich
 */
class Field{
	/** aktuelle Zustaendigkeitsgrenzen */
  public int left, top, right, bottom;
	/** urspruengliche Positionen */
	public int oLeft, oRight, oCx;
	/** Sollposition */
	public int centerX, centerY;
	/**	KickOff-Position */
	public int kickoffX, kickoffY;
	/** Zuspielpositionen */
	public int sideward[], forward[], backward[];
	//============================================================================
  /**
   * Initialisierung des Feldes
   * @param Left linker Feldrand
   * @param Top oberer Feldrand
   * @param Right rechter Feldrand
   * @param Bottom unterer Feldrand
   * @param cX x-Koordinate der Sollposition
   * @param cY y-Koordinate der Sollposition
   * @param kX x_koordinate der Kick-Off-Position
   * @param kY y_koordinate der Kick-Off-Position
  */
	public Field( int Left, int Top, int Right, int Bottom,
								int cX, int cY, int kX, int kY ){
		top = Top; bottom = Bottom; right = oRight = Right; left = oLeft = Left;
		centerX = oCx = cX; centerY = cY; kickoffX = kX; kickoffY = kY;
		forward = sideward = backward = null;
	}
	//============================================================================
	/**
	 * verschiebt Feld nach Ballposition
	 */
	public void moveTo( int ballX ){
		if( ballX < -4000 )ballX = -4000;
		if( ballX > 4000 )ballX = 4000;
		ballX /= 2;
		right = oRight + ballX; left = oLeft + ballX; centerX = oCx + ballX;
	}
	//============================================================================
  /**
   * ist Objekt nahe dem Feld?
   * @param Objekt nahe?
   */
	public boolean containsExtended( FieldObjekt objekt ){
		return containsExtended( objekt.x, objekt.y );
	}
	//============================================================================
  /**
   * ist Position nahe dem Feld?
   * @param Position nahe?
   */
	public boolean containsExtended( int x, int y ){
		return( left-750 <= x && right+750 >= x
						&& top-500 <= y && bottom+500 >= y );
	}
	//============================================================================
  /**
   * ist Objekt im Feld?
   * @param Objekt im Feld?
   */
	public boolean contains( FieldObjekt objekt ){
		return contains( objekt.x, objekt.y );
	}
	//============================================================================
  /**
   * ist Position im Feld?
   * @param Position im Feld?
   */
	public boolean contains( int x, int y ){
		return( left <= x && right >= x	&& top <= y && bottom >= y );
	}

}


/*
 * Version History:
 *
 * $Log: KI.java,v $
 * Revision 1.58  2002/07/14 14:36:04  richard
 * kosmetische Aenderungen
 *
 * Revision 1.57  2002/07/14 12:59:04  richard
 * Training Ver.4
 *
 * Revision 1.56  2002/07/14 12:02:31  richard
 * Trainigslager Ver.3
 *
 * Revision 1.55  2002/07/13 20:50:43  richard
 * Trainingslager Ver.2
 *
 * Revision 1.54  2002/07/13 20:09:31  richard
 * trainingslager ver1
 *
 * Revision 1.53  2002/07/11 18:53:05  dhenning
 * frher schiessen, felderberlappung in y-Richtung verringert
 *
 * Revision 1.52  2002/07/07 23:13:15  richard
 * verbessertes dashPower
 *
 * Revision 1.51  2002/07/07 11:33:05  dhenning
 * rumkommentiert
 *
 * Revision 1.50  2002/07/07 11:04:25  richard
 * mehr Kommentare
 *
 * Revision 1.49  2002/07/07 10:59:39  dhenning
 * paar kommentare hinzugefgt
 *
 * Revision 1.48  2002/07/07 10:45:02  richard
 * rueckpass eingebaut
 *
 * Revision 1.47  2002/07/06 11:31:49  richard
 * Kommentare eingefuegt
 *
 * Revision 1.46  2002/07/05 16:40:07  richard
 * allgemeines Optimieren
 *
 * Revision 1.45  2002/07/05 14:43:27  richard
 * intercept verbessert
 *
 * Revision 1.44  2002/07/05 11:52:58  dhenning
 * spieler rennen nicht mehr zum ball, wenn schon 2 andere nahe am ball sind
 *
 * Revision 1.43  2002/07/05 11:28:14  richard
 * friendliesNear hinzugefgt
 *
 * Revision 1.42  2002/07/05 11:10:07  richard
 * interception verbessert und Positionsbestimmung berarbeitet
 *
 * Revision 1.41  2002/07/04 19:43:00  richard
 * zum Ball laufen verbessert (hoffentlich)
 *
 * Revision 1.40  2002/07/04 13:00:06  richard
 * KI gefixt
 *
 * Revision 1.39  2002/07/04 12:23:09  dhenning
 * letzte nderung zurckgenommen
 *
 * Revision 1.38  2002/07/02 18:58:06  richard
 * auf neuen Algorithmus umgestellt
 *
 * Revision 1.37  2002/07/02 15:18:30  dhenning
 * Spieler beachten Freekick
 *
 * Revision 1.36  2002/07/02 12:03:28  richard
 * neuer Algorithmus fuer WorldModell
 *
 * Revision 1.35  2002/07/02 09:49:10  richard
 * KI optimiert
 *
 * Revision 1.34  2002/07/01 22:28:02  richard
 * aktuelle KI
 *
 * Revision 1.33  2002/06/30 10:02:16  richard
 * passspiel verbessert
 *
 * Revision 1.32  2002/06/29 20:20:56  richard
 * alternatives intercept aktiviert
 *
 * Revision 1.31  2002/06/29 18:10:12  richard
 * KI ueberarbeitet
 *
 * Revision 1.29  2002/06/27 19:52:00  richard
 * bewegende Fields gefixt
 *
 * Revision 1.28  2002/06/27 17:36:04  richard
 * KI: execute, Aktion fertig, und weitere kleinere Veraenderungen
 *
 * Revision 1.27  2002/06/27 15:26:50  dhenning
 * Felder gendert
 *
 * Revision 1.26  2002/06/27 14:30:27  richard
 * Konstanten fr Aktion
 *
 * Revision 1.25  2002/06/27 14:24:55  richard
 * KI Restrukturierung hat begonnen
 *
 * Revision 1.24  2002/06/25 20:05:16  richard
 * intercept korrigiert und Weltmodell Historytracking verbessert
 *
 * Revision 1.23  2002/06/25 11:08:02  richard
 * intercept aktiviert, hat offensichtlich noch einen Bug, laeuft aber meistens
 *
 * Revision 1.22  2002/06/24 22:00:56  richard
 * KI bearbeitet, intercept auskommentiert, da noch nicht zufriedenstellend...
 *
 * Revision 1.21  2002/06/23 21:23:41  richard
 * debug-message entfernt
 *
 * Revision 1.20  2002/06/23 21:06:47  richard
 * History in WorldModell eingefuegt, IO_Translate korrigiert bezueglich goal,
 * KI-Daten an DataCore verbessert, ...
 *
 * Revision 1.19  2002/06/22 10:20:35  phjung
 * History aktiviert, Bots legen vor,  Intercept verbessert,
 * Laufgeschwindigkeit verbessert, Entfernungsabhngige Schussstrke, Kleinigkeiten
 *
 * Revision 1.18  2002/06/21 14:51:47  phjung
 * abseits vorbereitet
 *
 * Revision 1.11  2002/06/18 07:55:58  dhenning
 * kommentiert
 *
 * Revision 1.10  2002/06/16 21:23:12  phjung
 * Goalie-catch, Passen und einfacher Abfangkurs zum Ball eingebaut
 *
 * Revision 1.8  2002/06/04 15:50:46  richard
 * KI optimiert
 *
 * Revision 1.7  2002/06/04 12:17:03  richard
 * Halbzeit und ViewMode bearbeitet
 *
 * Revision 1.6  2002/06/04 11:10:49  matthias
 * seitenwechsel eingefuegt
 *
 * Revision 1.5  2002/06/03 22:15:27  richard
 * KI erweitert und korrigiert, ChangeView erstellt und eingebaut,
 * laeuft jetzt
 *
 * Revision 1.4  2002/06/02 22:29:33  richard
 * habe diverse Korrekturen vorgenommen, KI geschrieben,
 * einige IO Bugs entfernt, usw.
 *
 * Revision 1.2  2002/05/28 14:31:52  bbleiffus
 * log4j Grundstruktur auskommentiert eingefgt
 *
 * Revision 1.1  2002/05/28 12:33:06  richard
 * moving files
 *
 * Revision 1.3  2002/05/25 14:55:23  richard
 * added package-statements, worked on the WorldModell, added Line-Class
 *
 * Revision 1.2  2002/05/24 14:21:21  richard
 * habe Log korrigiert
 *
 *
 */
