/*
 *	loque\Line.java
 *
 *	repraesentiert eine Linie
 *
 *  $Id: Line.java,v 1.7 2002/07/07 14:31:03 richard Exp $
 *
 */

package loque;



/**
 * repraesentiert eine Linie und haelt Daten fuer Berechnung des WorldModell
 */
public class Line{



	public static final short LineLeft = 0;
	public static final short LineTop = 1;
	public static final short LineRight = 2;
	public static final short LineBottom = 3;
	/** Winkel */
	private int dir;
	/** Entfernung */
	public int dist;
	/** Typ */
	private short typ;
	/**
	 * Konstruktor
	 */
	public Line( short Typ, int Dist, int Dir ){
		dir=Dir;dist=Dist;typ=Typ;
	}

	/* der kommende Teil wird vom WorldModell fr Berechnungen benoetigt */

	/** Richtung, in die Spieler guckt, berechnet nach dieser Linie */
	public int playerDir;
	/** RichtungsOffsets der Linien	 */
	private static final int OffSets[][]={{-18000,0},{-9000,9000},{0,18000},{9000,-9000}};
	/** berechnet playerDir */
	public int calculate(){
		return playerDir = DataCore.normAngle(OffSets[typ][dir<0?0:1]-dir);
	}
	/** invertiert playerDir */
	public int invertDir(){
		return playerDir += playerDir > 0 ? -18000 : 18000;
	}
	/** Delta playerDir bezueglich Referenzlinie */
	public int diffDir;
	/** berechnet diffDir */
	public int calcDiff( Line Ref ){
		diffDir = Ref.playerDir - playerDir;
		if( diffDir < 0 )diffDir = -diffDir;
		if( diffDir > 18000 )diffDir = 36000-diffDir;
		return diffDir;
	}
}


/*
 * Version History:
 *
 * $Log: Line.java,v $
 * Revision 1.7  2002/07/07 14:31:03  richard
 * Diverses privatisiert
 *
 * Revision 1.6  2002/07/06 20:02:47  matthias
 * Noch mehr Kommentare
 *
 * Revision 1.5  2002/06/03 22:15:27  richard
 * KI erweitert und korrigiert, ChangeView erstellt und eingebaut,
 * laeuft jetzt
 *
 * Revision 1.4  2002/06/02 22:29:33  richard
 * habe diverse Korrekturen vorgenommen, KI geschrieben,
 * einige IO Bugs entfernt, usw.
 *
 * Revision 1.3  2002/06/02 13:17:45  richard
 * Log4J aktiviert, Header korrigiert, Einheitenkommentare hinzugefuegt, Umrechnung der Einheiten hinzugefuegt, allgemeine Korrekturen
 *
 * Revision 1.2  2002/05/28 14:31:52  bbleiffus
 * log4j Grundstruktur auskommentiert eingefgt
 *
 * Revision 1.1  2002/05/28 12:33:06  richard
 * moving files
 *
 * Revision 1.1  2002/05/25 14:55:23  richard
 * added package-statements, worked on the WorldModell, added Line-Class
 *
 *
 *
 */