/*
 *	loque\Loque.java
 *
 *	erstellt Instanzen von Player
 *
 *  $Id: Loque.java,v 1.13 2002/07/14 14:36:04 richard Exp $
 *
 */


package loque;

// log4j Klassen importieren
import org.apache.log4j.Category;
import org.apache.log4j.Priority;
import org.apache.log4j.NDC;

import java.io.*;
import java.net.*;
/**
 * Hauptklasse
 */
public class Loque {

	static Category cat = Category.getInstance( Loque.class.getName());

  /** die Spieler */
  private static Player[] players;
	public static volatile boolean loop = true;
  /**
   * hier geht es los
   */
  public static void main( String[] args ){
		// Parameter pruefen
		if( args.length == 1 && args[0].equals("-h") ){
      System.out.println("java Loque [TEAMNAME] [SERVERNAME] [PORT] \n"+
                         "           [-p:<ListeningPort>] [NumberOfPlayers] [goalie]");
      System.exit(1);
		}
	  players = new Player[11];
		int listeningPort = 6010; int currArg = 0;
		int maxPlayers = 11, serverport = 6000, number = 11; 
		String servername = "localhost", team = "Loque";
		boolean goalie = true;
		for( int a = 0; a < args.length; a++ ){
			// explizite Angabe des Portes?
			if( args[a].startsWith( "-p:" ) ){
				listeningPort = Integer.parseInt( args[a].substring( 3 ).trim() );
				continue;
			}
			switch( currArg ){
			case 0: team = args[a]; break;
			case 1: servername = args[a]; break;
			case 2: serverport = Integer.parseInt(args[a]); break;
			case 3: maxPlayers = Integer.parseInt(args[a]); break;
			}
			currArg++;
  		// wieviel Spieler sollen es ein?
		}
		if( currArg == 4 )goalie = false;
		// Spieler erstellen!
		for( int a = 0; a < maxPlayers; a++ ){
			try{
				players[a] = new Player( a==0?goalie:false, servername, serverport, team );
				players[a].start();
			}catch( IOException exception ){
				System.out.println("An error occured during the creation of the players:");
	   		System.exit(1);
			}
		}
		// warten auf Monitorverbindungen
		// UDP-Packet mu folgende Struktur haben:
		// "connect <PlayerNumber> <hostaddress> <port>"
		// oder "shutdown" zum Beenden
		DatagramSocket socket;
		try{
			socket = new DatagramSocket( listeningPort );
			socket.setSoTimeout( 1000 );
		}catch( SocketException se ){
			cat.error("Loque: Konnte den Socket nicht erstellen."); socket = null;
		}
		if( socket != null )
			while( loop ){
				{
			    byte[] buffer = new byte[1024];
			    DatagramPacket packet = new DatagramPacket(buffer, buffer.length);
					try {
						socket.receive(packet);
					}catch(IOException dummy){
						packet.setData( new byte[1] ); packet.setLength( 0 );
					}
					try{
						String received = new String(packet.getData()).trim();
						// shutdown?
						if( received.equals( "shutdown" ) ){
							loop = false;
							for( int a = 0; a < maxPlayers; a++ )players[a].suicide = true;
							break;
						}
						// connect?
						if( received.startsWith( "connect " ) ){
							int index = received.indexOf( " ", 8 );
							int num = Integer.parseInt( received.substring( 8, index++ ) );
							int index2 = received.indexOf( " ", index );
							String host = received.substring( index, index2++ );
							int port = Integer.parseInt( received.substring( index2 ).trim() );
							for( int a = 0; a < maxPlayers; a++ )
								if( players[a] != null && players[a].datacore.num == num ){
									if( players[a].monClient == null ){
										try{
											players[a].monClient = new MonitorClient( players[a], host, port );
										}catch( Throwable dummy){
                      cat.error( dummy );
                      players[a].monClient = null;
                    }
									}
									break;
								}
						}
					}catch( Throwable dummy ){}
				}
			}
  }
}

/*
 * Version History:
 *
 * $Log: Loque.java,v $
 * Revision 1.13  2002/07/14 14:36:04  richard
 * kosmetische Aenderungen
 *
 * Revision 1.12  2002/07/07 11:04:25  richard
 * mehr Kommentare
 *
 * Revision 1.11  2002/07/05 17:40:16  richard
 * shutdown vorbereitet
 *
 * Revision 1.10  2002/07/04 19:43:00  richard
 * zum Ball laufen verbessert (hoffentlich)
 *
 * Revision 1.9  2002/06/18 15:16:39  richard
 * numFriends,... zu DataCore hinzugefuegt und in WorldModell eingebaut,
 * ListeningPort jetzt dynamisch ueber Commandozeile
 *
 * Revision 1.8  2002/06/18 11:47:10  richard
 * player crashsicherer
 *
 * Revision 1.7  2002/06/18 11:13:53  richard
 * KI rumgepfuscht
 *
 * Revision 1.6  2002/06/10 11:12:19  richard
 * tcp-verbindung korrigiert
 *
 * Revision 1.5  2002/06/04 19:15:28  richard
 * Empfangsteil in Loque eingebaut
 *
 * Revision 1.4  2002/06/02 22:29:33  richard
 * habe diverse Korrekturen vorgenommen, KI geschrieben,
 * einige IO Bugs entfernt, usw.
 *
 * Revision 1.3  2002/06/02 13:17:45  richard
 * Log4J aktiviert, Header korrigiert, Einheitenkommentare hinzugefuegt, Umrechnung der Einheiten hinzugefuegt, allgemeine Korrekturen
 *
 * Revision 1.2  2002/05/28 14:31:52  bbleiffus
 * log4j Grundstruktur auskommentiert eingefgt
 *
 * Revision 1.1  2002/05/28 12:33:06  richard
 * moving files
 *
 * Revision 1.5  2002/05/25 20:56:07  richard
 * Feel-Class hinzugefuegt and deren Auswertung
 *
 * Revision 1.4  2002/05/25 16:50:07  richard
 * rudimentaeres StartUp erstellt, Haupt-Playerschleife und Login hinzugefuegt
 *
 * Revision 1.3  2002/05/25 14:55:23  richard
 * added package-statements, worked on the WorldModell, added Line-Class
 *
 * Revision 1.2  2002/05/24 14:21:21  richard
 * habe Log korrigiert
 *
 *
 */