/*
 *	loque\See.java
 *
 *	Modellierung der SEE-Nachricht
 *
 *
 * $Id: See.java,v 1.10 2002/07/07 14:31:03 richard Exp $
 */

package loque;


/**
 * dient der Uebertragung der Daten der See-Message
 */
public class See{

	/* Konstanten */
	public static final short Ball = 0;
	public static final short Friend = 1;
	public static final short Enemy = 2;
	public static final short Unknown = 3;
	/**
	 * Attribute
	 */
	public short team;
	private short num;
	private int dir, dist;
	private int distChng, dirChng;
	/**
	 * Konstruktor
	 */
	public See( short iTeam, short iNum, int iDist, int iDir, int iDistChng, int iDirChng ){
		team = iTeam; distChng = iDistChng; dist = iDist;
		num = iNum; dir = iDir; dirChng = iDirChng;
	}
	/** erzeugt ein FieldObjekt anhand der Daten */
	public FieldObjekt eval( int px, int py, int pvx, int pvy, int pdir ){
		double absDir = (pdir+dir)*0.01*Math.PI/180.0;//absoluter Winkel in Radiant
    double erx = Math.sin( absDir ), ery = -Math.cos( absDir );//radialer Einheitsvektor
    double x = px + dist * erx, y = py + dist * ery; //x,y in 1/100
    double vt = Math.tan(dirChng*Math.PI/18000.0)*dist;// tangentiale Geschw.
    double vx = erx*distChng-ery*vt+pvx; //absolute Geschw. in X-Richtung in 1/100
    double vy = ery*distChng+erx*vt+pvy; //absolute Geschw. in Y-Richtung in 1/100
    double va = Math.sqrt( vx*vx+vy*vy ); //absolute Geschw. in 1/100
		double adir = 0.0;
		if( va > 5.0 )adir = 18000.0/Math.PI*Math.atan2( vx,-vy );// abs. Richtung
		return new FieldObjekt( (int)(x),(int)(y), (int)(vx), (int)(vy), (int)(va),
                            (int)(adir), num, DataCore.normAngle(pdir+dir), dist, team );
	}

}


/*
 * Version History:
 *
 * $Log: See.java,v $
 * Revision 1.10  2002/07/07 14:31:03  richard
 * Diverses privatisiert
 *
 * Revision 1.9  2002/07/06 20:02:47  matthias
 * Noch mehr Kommentare
 *
 * Revision 1.8  2002/06/25 11:08:02  richard
 * intercept aktiviert, hat offensichtlich noch einen Bug, laeuft aber meistens
 *
 * Revision 1.7  2002/06/23 21:06:47  richard
 * History in WorldModell eingefuegt, IO_Translate korrigiert bezueglich goal,
 * KI-Daten an DataCore verbessert, ...
 *
 * Revision 1.6  2002/06/18 10:15:26  richard
 * geschwindigkeiten und richtungen werden jetzt berechnet
 *
 * Revision 1.5  2002/06/03 22:15:27  richard
 * KI erweitert und korrigiert, ChangeView erstellt und eingebaut,
 * laeuft jetzt
 *
 * Revision 1.4  2002/06/02 22:29:34  richard
 * habe diverse Korrekturen vorgenommen, KI geschrieben,
 * einige IO Bugs entfernt, usw.
 *
 * Revision 1.3  2002/06/02 13:17:45  richard
 * Log4J aktiviert, Header korrigiert, Einheitenkommentare hinzugefuegt, Umrechnung der Einheiten hinzugefuegt, allgemeine Korrekturen
 *
 * Revision 1.2  2002/05/28 14:31:52  bbleiffus
 * log4j Grundstruktur auskommentiert eingefgt
 *
 * Revision 1.1  2002/05/28 12:33:06  richard
 * moving files
 *
 * Revision 1.2  2002/05/25 16:50:07  richard
 * rudimentaeres StartUp erstellt, Haupt-Playerschleife und Login hinzugefuegt
 *
 * Revision 1.1  2002/05/25 15:06:53  richard
 * Notloesung fuer See.java
 *
 * Revision 1.4  2002/05/25 14:55:23  richard
 * added package-statements, worked on the WorldModell, added Line-Class
 *
 * Revision 1.3  2002/05/24 14:21:21  richard
 * habe Log korrigiert
 *
 *
 */