/*
 *	monitor\src\Monitor.java
 *
 *
 *
 */

package monitor;
import javax.swing.UIManager;
import java.awt.*;
import loque.*;


/**
 * <p>Title: Player Surveillance System</p>
 * <p>Description: Monitor of loque</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Sebastian Essers
 * @version 1.x
 */



public class Monitor extends Thread{
	boolean packFrame = false;


	static int pln=0,prt=0;
	static String ipn="null";

	MonitorGUI frame = new MonitorGUI();

	public static volatile DataCore data;
	static boolean connected=false;
	static int lastCycle=0;

	public static MonitorServer server;


	//Construct the application

	public Monitor() {


		//Validate frames that have preset sizes
		//Pack frames that have useful preferred size info, e.g. from their layout
		if (packFrame) {
			frame.pack();
		}
		else {
			frame.validate();
		}
		//Center the window
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = frame.getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		frame.setVisible(true);
		frame.setResizable(false);

	}

	/**runmon: Methode mit Endlosschleife:ruft connect() auf, falls die ntigen Parameter gesetzt sind
	 * und liest dann die Daten aus dem erhaltenen DataCore Object aus und schreibt sie in die
	 * dafr vorgesehenen Variablen in JPfield*/
	public void run(){
		boolean ja=true;
		while(ja){
			if(ipn=="null"&&prt==0 && pln==0){                      //noch keine Adresse angegeben?
				try{ sleep( 50 ); }
				catch( Exception dummy ){}
			}
			else{                                                  // doch!!
				connect(ipn,prt,pln);
				frame.jPfield.status=5;
				while(frame.jPfield.status!=250){
					int i;
					if(connected && data != null && data.cycle>lastCycle && (int)data.num==frame.pl_nr){
						frame.sh_cycle.setText("Cycle: "+Integer.toString(data.cycle));
						frame.viewwidth.setText("View Width:  Mode"+Short.toString(data.viewWidth));
						lastCycle=data.cycle;
						int jb=0;
						for(i=0;i<22;i++){              //initial and delete
							frame.jPfield.fobj[i][0]=0;
							frame.jPfield.fobj[i][1]=0;
							frame.jPfield.fobj[i][2]=0;
						}
						if(data.ball!=null){
							frame.jPfield.fobj[0][0]=(data.ball.x/100)*5+262+25;
							frame.jPfield.fobj[0][1]=(data.ball.y/100)*5+170+25;
							frame.jPfield.fobj[0][2]=4;//Ball-kennung
							jb=1;
						}
						for(i=0;i< data.numFriends;i++){
							if(data.friend[i]!=null){
								frame.jPfield.fobj[jb][0]=(data.friend[i].x/100)*5+262+25;
								frame.jPfield.fobj[jb][1]=(data.friend[i].y/100)*5+170+25;
								frame.jPfield.fobj[jb][2]=1;//freund-kennung
								jb++;
							}
						}
						for(i=0;i< data.numEnemies;i++){
							if(data.enemy[i]!=null){
								frame.jPfield.fobj[jb][0]=(data.enemy[i].x/100)*5+262+25;
								frame.jPfield.fobj[jb][1]=(data.enemy[i].y/100)*5+170+25;
								frame.jPfield.fobj[jb][2]=2;//feind-kennung
								jb++;
							}
						}
						//unknown, was knnte das wohl sein???
						for(i=0;i< data.numUnknowns;i++){
							if(data.unknown[i]!=null){
								frame.jPfield.fobj[jb][0]=(data.unknown[i].x/100)*5+262+25;
								frame.jPfield.fobj[jb][1]=(data.unknown[i].y/100)*5+170+25;
								frame.jPfield.fobj[jb][2]=3;//unknown-kennung
								jb++;
							}
						}
						//Player
						frame.jPfield.pl_x=(data.x/100)*5+263+25;
						frame.jPfield.pl_y=(data.y/100)*5+170+25;
						frame.jPfield.pl_view_dir=-((data.dir/100)+data.headdir/100);
						frame.jPfield.pl_vx=(data.vx)*5/10;
						frame.jPfield.pl_vy=(data.vy)*5/10;
						frame.jPfield.stamina=data.stamina;
						frame.jPfield.view_szx=10*20*(3-(int)data.viewWidth);
						frame.jPfield.view_szy=10*(20*(3-(int)data.viewWidth));
						if(data.viewWidth==0)
							frame.jPfield.pl_view_arc=45;
						else
							if(data.viewWidth==1)
								frame.jPfield.pl_view_arc=90;
							else
								frame.jPfield.pl_view_arc=180;

						frame.jPfield.repaint();
					}//endofif
					else{
						try{ sleep( 50 ); }
						catch( Exception dummy ){}
					}
				}//inner while
				frame.shwplnr.setText(frame.shwplnr.getText()+"->Ende");//zum testen
				data=null;
			}
		}


	}
	/**connect: Methode ruft MonitorServer auf
	 * und bergibt Verbindungsparameter */
	private static void connect(String client, int port, int spieler ){
		server = new MonitorServer ( client, 6010, spieler );
		server.start();
		connected=true;
	}

	//Main method                                 /**main: Hier wird so gut wie gar nichts gemacht */
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		Monitor temp = new Monitor();
		temp.run();
	}
}

/*
 * Version History:
 *
 * $Log: Monitor.java,v $
 * Revision 1.19  2002/07/07 23:30:55  richard
 * auf thread-mode umgestellt
 *
 * Revision 1.18  2002/07/07 09:43:51  sebastian
 * seems to be the FINAL
 * (to shutdown loque is only possible if monitor is connected)
 *
 * Revision 1.13  2002/06/18 11:47:10  richard
 * player crashsicherer
 *
 * Revision 1.12  2002/06/18 07:24:30  sebastian
 * noch ein paar kleine nderungen
 *
 * Revision 1.7  2002/06/09 13:38:31  sebastian
 * integration von datacore und monitor-server
 *
 * Revision 1.6  2002/06/07 11:59:06  bbleiffus
 * Es wird ein Objekt (wahrscheinlich DataCore) vom MonitorClient
 * gesendet und vom MonitorServer empfangen.
 * TCP Verbindung steht, aber bisher nur eine bertragung nicht dauernd !
 *
 * Revision 1.5  2002/06/07 11:21:37  bbleiffus
 * Formatierungsfehler behoben:
 * Klassenname und Konstruktor in Monitor haben nicht gestimmt
 * package Monitor in monitor gendert, da im Verzeichnis auch klein
 *
 * Revision 1.4  2002/06/03 17:33:48  sebastian
 * :(
 *
 * Revision 1.3  2002/05/24 14:21:21  richard
 * habe Log korrigiert
 *
 *
 */