/*
 *	monitor\src\MonitorGUI.java
 *
 *
 */

package monitor;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * <p>Title: Player Surveillance System GUI</p>
 * <p>Description: Monitor GUI of loque</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Sebastian Essers
 * @version 1.x
 */

/** Alle Elemente der GUI werden erstellt/initialisiert*/
public class MonitorGUI extends JFrame {
	JPanel contentPane;
	BorderLayout borderLayout1 = new BorderLayout();
	JPanel jPanell = new JPanel();
	JPfield jPfield = new JPfield();
	Color farbe = new Color(0,150,0);
	JButton pic = new JButton(new ImageIcon("woodscr.gif"));
	Box box1 = Box.createVerticalBox();
	JButton btn1=new JButton("Exit");
	JSlider plNr=new JSlider(JSlider.HORIZONTAL,1,11,1);
	JLabel pl = new JLabel("Spielernummer:");
	JLabel ipadr = new JLabel("Host Adresse:");
	JLabel port = new JLabel("Port:");
	JLabel shwplnr = new JLabel("1");
	JLabel sh_cycle=new JLabel("Cycle:");
	JButton login=new JButton("Connect");
	JLabel viewwidth = new JLabel("View Width:");
	JTextField tfip=new JTextField("localhost",15);
	JTextField tfport=new JTextField("6010",4);
	JButton shutdown=new JButton("Shutdown Loque");

	int pl_nr;

	//Construct the frame
	public MonitorGUI() {
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}


	//Component initialization
	private void jbInit() throws Exception  {

		//setIconImage(Toolkit.getDefaultToolkit().createImage(monitorGUI.class.getResource("[Your Icon]")));
		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(borderLayout1);
		this.setSize(new Dimension(775, 425));
		this.setTitle("Player Surveillance System");

		jPanell.setLayout(new BoxLayout(jPanell, BoxLayout.X_AXIS));
		jPanell.setMinimumSize(new Dimension(200, 480));
		jPanell.setPreferredSize(new Dimension(200, 480));
		jPanell.setSize(200,480);
		jPanell.setBorder(BorderFactory.createBevelBorder(1));

		/** Eventhandling */
		btn1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseReleased(MouseEvent e) {
			btn1_mouseReleased(e);
			}
			});

		plNr.addChangeListener(new javax.swing.event.ChangeListener() {
			public void stateChanged(ChangeEvent e) {
			plNr_stateChanged(e);
			}
			});
		login.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseReleased(MouseEvent e) {
			login_mouseReleased(e);
			}
			});
		tfip.setMaximumSize(new Dimension(150, 25));
		tfip.setMinimumSize(new Dimension(4, 20));
		tfip.setPreferredSize(new Dimension(165, 25));
		tfport.setMaximumSize(new Dimension(150, 25));
		tfport.setMinimumSize(new Dimension(150, 25));
		tfport.setPreferredSize(new Dimension(150, 25));
		shutdown.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseReleased(MouseEvent e) {
			shutdown_mouseReleased(e);
			}
			});
		contentPane.add(jPanell,BorderLayout.WEST);

		pic.addMouseListener(new java.awt.event.MouseAdapter(){
			public void mouseReleased(MouseEvent e){
			pic_mouseReleased(e);
			}
			});
		/** Eigenschaftzuweisung der visuellen Komponenten und zuweisen zu den Layoutmanagern*/
		jPanell.setBackground(Color.lightGray);
		jPfield.setBackground(farbe);
		contentPane.add(jPfield,BorderLayout.CENTER);
		jPanell.setLayout(new BorderLayout());
		jPanell.add(btn1,BorderLayout.SOUTH);

		pic.setBackground(Color.white);
		//pic.setBorder(BorderFactory.createEtchedBorder(getBackground().darker(),getBackground().brighter()));
		jPanell.add(pic,BorderLayout.NORTH);
		pl.setAlignmentX(Component.LEFT_ALIGNMENT);
		box1.add(pl);
		shwplnr.setAlignmentX(Component.LEFT_ALIGNMENT);
		box1.add(shwplnr);

		plNr.setMajorTickSpacing(1);
		plNr.setPaintTicks(true);
		plNr.setPaintLabels(true);
		plNr.setAlignmentX(Component.LEFT_ALIGNMENT);
		box1.add(plNr);
		ipadr.setAlignmentX(Component.LEFT_ALIGNMENT);
		box1.add(ipadr);
		box1.add(tfip);
		tfip.setAlignmentX(Component.LEFT_ALIGNMENT);
		port.setAlignmentX(Component.LEFT_ALIGNMENT);
		box1.add(port);
		tfport.setAlignmentX(Component.LEFT_ALIGNMENT);
		box1.add(tfport);
		box1.add(login);
		box1.add(viewwidth);
		box1.add(sh_cycle);
		box1.add(shutdown);
		jPanell.add(box1,BorderLayout.WEST);
	}
	//Overridden so we can exit when window is closed
	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	}
	/** Eventhandling die Zweite -> Handlungen werden den Ereignissen zugewiesen */
	void btn1_mouseReleased(MouseEvent e) {
		System.exit(0);
	}
	/**Help!*/
	void pic_mouseReleased(MouseEvent e){
		JOptionPane.showMessageDialog(contentPane,"Hinweis: Es hilft im Fehlerfall oft das Programm neu zu starten\n\nFarbcodierung:\nBlau:Spieler gleicher Mannschaft\nRot: Gegner\nGrau:Unbekannter Spieler\nWei: Ball\nGelb: berwachter Spieler\n\nLinien nach FIFA\n","Help",JOptionPane.INFORMATION_MESSAGE);
	}

	//Schieberegler verndert?
	void plNr_stateChanged(ChangeEvent e) {
		int trans;
		trans=plNr.getValue();
		shwplnr.setText(Integer.toString(trans));
	}

	//login Button losgelassen : fhrt dazu da auf den Spieler connectiert bzw. disconnectiert wird
	public void login_mouseReleased(MouseEvent e) {
		if(login.getText()=="Connect"){
			Monitor.ipn=tfip.getText();
			Monitor.prt=Integer.parseInt(tfport.getText());
			Monitor.pln=(int)plNr.getValue();
			sh_cycle.setText("OK");
			login.setText("Disconnect");
			pl_nr=(int)plNr.getValue();
		}
		else{
			Monitor.ipn="null";
			Monitor.prt=0;
			Monitor.pln=0;
			login.setText("Connect");
			jPfield.status=250;

		}

	}
	/**Try to shutdown the client : Funktion in MonitorServer*/
	void shutdown_mouseReleased(MouseEvent e) {
		if(MonitorServer.shutdown(Monitor.ipn,Monitor.prt)==0)
			JOptionPane.showMessageDialog(contentPane,"Fehler beim Beenden von Loque","Fehler",JOptionPane.ERROR_MESSAGE);
	}

}

/*
 * Version History:
 *
 * $Log: MonitorGUI.java,v $
 * Revision 1.17  2002/07/07 23:30:55  richard
 * auf thread-mode umgestellt
 *
 * Revision 1.16  2002/07/07 09:43:51  sebastian
 * seems to be the FINAL
 * (to shutdown loque is only possible if monitor is connected)
 *
 * Revision 1.15  2002/06/30 18:22:51  sebastian
 * no message
 *
 * Revision 1.7  2002/06/09 13:40:08  sebastian
 * integration von datacore und monitor-server sichtbereich dargestellt
 *
 * Revision 1.6  2002/06/07 11:21:37  bbleiffus
 * Formatierungsfehler behoben:
 * Klassenname und Konstruktor in Monitor haben nicht gestimmt
 * package Monitor in monitor gendert, da im Verzeichnis auch klein
 *
 * Revision 1.5  2002/06/03 17:33:48  sebastian
 * :(
 *
 */